#include <gdsnstd.h>
#include <timlib.h>

/*  Spanning cases

==============================================================================
NIL		AAAAAAAAAAAAAAAAAA
					BBBBBBBBBBBBBBBBBBBBBBB
EMPTY
==============================================================================
ACB		AAAAAAAAAAAAAAAAAAAA
		      BBBBBBBBBB
B		      ----------
==============================================================================
BCA		      AAAAAAAAAAA
		BBBBBBBBBBBBBBBBB
A		      -----------
==============================================================================
ALB		AAAAAAAAAAAAAAAA
			BBBBBBBBBBBBBBBBBBB
SB-EA		        --------
==============================================================================
BLA		        AAAAAAAAAAAAAAAA
SA-EB		BBBBBBBBBBBBBBB
                        -------
==============================================================================

*/


extern STDTIME _ztime;

int ST_TimeSpan(STDTIME starta,STDTIME enda,
		STDTIME startb,STDTIME endb,
		STDTIME *retstart,STDTIME *retend)
{

	STDTIME copy;
	int ord=0;


	/* Make a's start time first */

	if (ST_TimeComp(starta,startb)>0) {
		copy = startb;
		startb = starta;
		starta = copy;
		copy = endb;
		endb = enda;
		enda = copy;
		ord = 1;
	}

	if (ST_TimeComp(startb,enda)>0) {
		*retstart = _ztime;
		*retend = _ztime;
		return(ST_SPAN_NIL);	/* No intersection */
	}

	if (ST_TimeComp(enda,endb)>0) {
		*retstart = startb;
		*retend = endb;
		return(ord?ST_SPAN_BCA:ST_SPAN_ACB);
	}

	*retstart = startb;
	*retend = enda;
	
	return(ord?ST_SPAN_BLA:ST_SPAN_ALB);

}
