#ifndef TMLB_DEFINED
#define TMLB_DEFINED

struct	sjtim	{		/* Day of year pseudo-julian date form */
	WORD	year;
	WORD	day;
	BYTE	hour;
	BYTE	minute;
	BYTE	second;
	WORD	msec;
};

#define STDTIME struct sjtim

struct	deltatime	{	/* Difference of a time amount */
	LONG	nday;
	UBYTE	nhour;
	UBYTE	nmin;
	UBYTE	nsec;
	UWORD	nmsecs;
};

#define DELTA_T struct deltatime

#define zerotime(x) (x.year == 0)

#define tpr(x) tfpr(stdout,x)
LONG	timsb();
BOOL	tleap();
STDTIME	*timall();

#define FLTTIME double		/* Number of seconds since julian instant */

#define TM_MILEN 1000
#define TM_CENT 100
#define TM_DECADE 10

#define TIM_LIM (20L*86400L*1000L)	/* Time limit (fits in 31 bits) */
					/* 20 Days */

#define ST_SPAN_NIL	0	/* No intersection */
#define ST_SPAN_ACB	1	/* A contains B */
#define ST_SPAN_BCA	2	/* B contains A */
#define ST_SPAN_ALB	3	/* A less than B */
#define ST_SPAN_BLA	4	/* B less than A */

LONG 	_julday(LONG year,LONG mon,LONG day);
VOID 	ST_CnvJulToCal(LONG injul,WORD *outyr,WORD *outmon,
		WORD *outday,WORD *outjday);
DELTA_T ST_AddToDelta(DELTA_T intime,LONG dd,LONG dh,
		LONG dm,LONG ds,LONG dms);
STDTIME	ST_AddToTime(STDTIME intime,LONG dd,LONG dh,
		LONG dm,LONG ds,LONG dms);
STDTIME	ST_CleanDate(STDTIME indate,WORD epoch,ULONG timflgs);
int 	ST_DeltaComp(DELTA_T intime,DELTA_T insect);
UBYTE 	*ST_DeltaPrint(DELTA_T delta,BOOL printplusflag,BOOL fixms);
LONG 	ST_DeltaToMS(DELTA_T indelta);
DELTA_T	ST_DiffTimes(STDTIME intime,STDTIME insect);
STDTIME	ST_FLTToTime(FLTTIME intime);
DELTA_T ST_FormDelta(LONG dd,LONG dh,LONG dm,LONG ds,LONG dms);
LONG	ST_GetJulian(STDTIME intime);
DELTA_T	ST_MinusDelta(DELTA_T indelta);
STDTIME	ST_ParseTime(UBYTE *inbuff);
UBYTE 	*ST_PrintCalDate(STDTIME odate,BOOL longfmt);
UBYTE 	*ST_PrintDate(STDTIME odate,BOOL fixfmt);
BOOL 	_tleap(WORD year);
STDTIME ST_GetCurrentTime();
LONG 	_calyear(LONG dy,LONG epoch,ULONG timflgs);
STDTIME	ST_SetupDate(LONG dy,LONG dd,LONG dh,LONG dm,
		LONG ds,LONG dms,WORD epoch,ULONG timflgs);
UBYTE 	*ST_SpanPrint(STDTIME ftime,STDTIME etime,BOOL fixfmt);
int 	ST_TimeComp(STDTIME intime,STDTIME insect);
STDTIME	ST_TimeMinusDelta(STDTIME intime,DELTA_T indelta);
STDTIME	ST_TimePlusDelta(STDTIME intime,DELTA_T indelta);
FLTTIME	ST_TimeToFLT(STDTIME intime);
VOID 	timenorm(LONG *dy,LONG *dd,LONG *dh,LONG *dm,LONG *ds,LONG *dms);
VOID 	timenormd(LONG *dd,LONG *dh,LONG *dm,LONG *ds,LONG *dms);

int ST_TimeSpan(STDTIME starta,STDTIME enda,
		STDTIME startb,STDTIME endb,
		STDTIME *retstart,STDTIME *retend);
#endif
